import tornado.ioloop
import tornado.log
import tornado.options
import tornado.web
from ai_callback_handler import AiCallBackAddCreative, AiCallBackAddGroup
from advertiser_strategy_operate import AddAdvertiserStrategy
from ai_time_task_creative_handler import AiHistoricalMissingMaterial, AiAutoCreative, AiHighQualityMaterial, \
    AiUpCreativeByHour, AiProgramCreativeHighQualityMaterial, AiProgramCreativeNewMaterial

import platform


def create_application():
    web_application = tornado.web.Application([
        (r"/ai_callback_add_group", AiCallBackAddGroup),
        (r"/ai_callback_add_creative", AiCallBackAddCreative),
        (r"/add_advertiser_strategy", AddAdvertiserStrategy),
        (r"/ai_historical_missing_material", AiHistoricalMissingMaterial),
        (r"/ai_auto_creative", AiAutoCreative),
        (r"/ai_high_quality_material", AiHighQualityMaterial),
        (r"/ai_up_creative_by_hour", AiUpCreativeByHour),
        (r"/ai_programme_high_quality_material", AiProgramCreativeHighQualityMaterial),
        (r"/ai_programme_new_material", AiProgramCreativeNewMaterial),
    ])
    return web_application


if __name__ == "__main__":
    application = create_application()
    http_server = tornado.httpserver.HTTPServer(application)
    http_server.bind(31012, None)
    if platform.system() == 'Windows':
        http_server.start()
    else:
        http_server.start(num_processes=5)
    tornado.ioloop.IOLoop.instance().start()

